// This class was created by JaTiTV.

package net.t2code.autoresponse.Spigot.config.config;

import net.t2code.autoresponse.Spigot.Main;
import net.t2code.autoresponse.Util;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2C_ConfigWriter;
import net.t2code.t2codelib.SPIGOT.system.T2C_Main;
import net.t2code.t2codelib.SPIGOT.system.config.config.T2C_LibConfig;
import net.t2code.t2codelib.util.T2C_ConfigItem;
import net.t2code.t2codelib.util.T2C_LanguageEnum;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.util.HashMap;
import java.util.List;

public class Config {
    public enum VALUES implements T2C_ConfigItem {
        language("plugin.language", T2C_LanguageEnum.english, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of("In dieser Option kannst du die Sprache des Plugins einstellen."));
            put(T2C_LanguageEnum.english, List.of("In this option you can set the language of the plugin."));
        }}),
        updateCheckOnJoin("plugin.updateCheck.onJoin", true, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        updateCheckSeePreReleaseUpdates("plugin.updateCheck.seePreReleaseUpdates", true, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        updateCheckTimeInterval("plugin.updateCheck.timeInterval", 60, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        keywordSeparation("plugin.responseKeys.keywordSeparation", "##", true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        logConsole("log.console.enable", true, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),

        ;

        private final String path;
        private Object value;
        private final boolean forceSet;
        private final HashMap<T2C_LanguageEnum, List<String>> comments;

        VALUES(String path, Object value, boolean forceSet, HashMap<T2C_LanguageEnum, List<String>> comments) {
            this.path = path;
            this.value = value;
            this.forceSet = forceSet;
            this.comments = comments;
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            return value;
        }

        @Override
        public boolean getForceSet() {
            return forceSet;
        }

        @Override
        public HashMap<T2C_LanguageEnum, List<String>> getComments() {
            return comments;
        }

        @Override
        public String getLanguagePath() {
            return language.path;
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }

    public static void set(boolean isReload) {
        convert();
        T2C_ConfigWriter.createConfig(Util.getPrefix(), new File(Main.getPath(), "config.yml"), T2C_LibConfig.VALUES.values(), isReload, Util.getConfigLogo());
    }

    private static void convert() {
        File config = new File(Main.getPath(), "config.yml");

        if (!config.exists()) return;
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);

        if (!yamlConfiguration.contains("Plugin")) return;

        set("Plugin.language", VALUES.language, yamlConfiguration);
        set("Plugin.updateCheck.onJoin", VALUES.updateCheckOnJoin, yamlConfiguration);
        set("Plugin.updateCheck.seePreReleaseUpdates", VALUES.updateCheckSeePreReleaseUpdates, yamlConfiguration);
        set("Plugin.updateCheck.timeInterval", VALUES.updateCheckTimeInterval, yamlConfiguration);
        set("Plugin.responseKeys.keywordSeperation", VALUES.keywordSeparation, yamlConfiguration);
        set("Log.Console.Enable", VALUES.logConsole, yamlConfiguration);
    }

    private static void set(String path, T2C_ConfigItem item, YamlConfiguration yamlConfiguration) {
        if (yamlConfiguration.contains(path)) {
            item.setValue(yamlConfiguration.get(path));
        }
    }
}
